#!/bin/bash

source common.sh;

function identify(){
	export other_hello="$(proto_expect "${code_hello_server}" "Server should greet me")";
	test "${other_hello}" != "error";
	echo "${code_hello_client} buddy, what's up?.";
}

function get_combined_token(){
	echo "${other_token}::${own_token}";
}

function get_commitment(){
	export bet="$(ask_coin "On which side of the coin do you want to bet?")";
	export coded_bet="$(code_bet "${bet}")";

	hash_string "${coded_bet}";
}

function send_commitment(){
	echo -n "${code_commitment} ";
	get_commitment;
}

function send_coded_bet(){
	echo "${code_reveal_bet} ${coded_bet}";
}

function get_coin(){
	export coin="$(proto_expect "${code_flip_result}" "Do you flip or not?")";
	test "${coin}" != "error";
}

function do_client(){
	set -e;
	identify;
	get_declare;
	declare_info;
	get_session_token;
	send_commitment;
	get_coin;
	send_coded_bet;
	get_winner;
	goodbye;
}

function start_client(){
	host="${1}";
	port="$(get_port)";
	echo "Opening connection to server (${host}:${port})..." >&2;

	nc "${host}" "${port}" -c "$(get_do_script)";
}

if [ $# -ne 1 ] || [ "$1" != "do" ]; then
	if [ $# -eq 1 ]; then
		start_client $1;
	else
		echo "Usage: client.sh hostname" >&2;
	fi;
else
	do_client;
fi;
